<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:04 CET 2009 -->
<TITLE>
IntegerUtil
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.util.numeric.IntegerUtil class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="IntegerUtil";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/IntegerUtil.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/util/numeric/DoubleUtil.html" title="class in ch.javasoft.util.numeric"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/util/numeric/Zero.html" title="class in ch.javasoft.util.numeric"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/util/numeric/IntegerUtil.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="IntegerUtil.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.util.numeric</FONT>
<BR>
Class IntegerUtil</H2>
<PRE>
<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>ch.javasoft.util.numeric.IntegerUtil</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.40"><B>IntegerUtil</B></A><DT>extends <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></DL>
</PRE>

<P>
The <code>IntegerUtil</code> contains static utility methods concerning
 integers (int and long).
<P>

<P>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#extendedEuclidean(int, int)">extendedEuclidean</A></B>(int&nbsp;a,
                                   int&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The extended euclidean algorithm solves the equation
 <tt>a*x + b*y = gcd(a,b)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#extendedEuclidean(long, long)">extendedEuclidean</A></B>(long&nbsp;a,
                                   long&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The extended euclidean algorithm solves the equation
 <tt>a*x + b*y = gcd(a,b)</tt>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#gcd(int...)">gcd</A></B>(int...&nbsp;values)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Calculates the greatest common divisor of the specified integer numbers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#gcd(java.lang.Integer...)">gcd</A></B>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Integer.html" title="class or interface in java.lang">Integer</A>...&nbsp;values)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Calculates the greatest common divisor of the specified integer numbers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#gcd(int, int)">gcd</A></B>(int&nbsp;iA,
       int&nbsp;iB)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the greatest common divisor of iA and iB using standard euclidian
 algorithm</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#gcd(long...)">gcd</A></B>(long...&nbsp;values)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Calculates the greatest common divisor of the specified long numbers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#gcd(java.lang.Long...)">gcd</A></B>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Long.html" title="class or interface in java.lang">Long</A>...&nbsp;values)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Calculates the greatest common divisor of the specified long numbers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#gcd(long, long)">gcd</A></B>(long&nbsp;iA,
       long&nbsp;iB)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the greatest common divisor of iA and iB using standard euclidian
 algorithm</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#modularReciprocal(int, int)">modularReciprocal</A></B>(int&nbsp;a,
                                   int&nbsp;mod)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes the reciprocal or multiplicative inverse of a (modulo mod).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#modularReciprocal(long, long)">modularReciprocal</A></B>(long&nbsp;a,
                                   long&nbsp;mod)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes the reciprocal or multiplicative inverse of a (modulo mod).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#modularReciprocal2pow32(int)">modularReciprocal2pow32</A></B>(int&nbsp;a)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes the reciprocal or multiplicative inverse of a (modulo 2^32).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#modularReciprocal2pow64(long)">modularReciprocal2pow64</A></B>(long&nbsp;a)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Computes the reciprocal or multiplicative inverse of a (modulo 2^64).</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#signum(int)">signum</A></B>(int&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the signum of the int value, i.e.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/util/numeric/IntegerUtil.html#signum(long)">signum</A></B>(long&nbsp;value)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns the signum of the long value, i.e.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="signum(long)"><!-- --></A><H3>
signum</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.48"><B>signum</B></A>(long&nbsp;value)</PRE>
<DL>
<DD>Returns the signum of the long value, i.e. 1/-1/0 for a positive, 
 negative or zero value
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Math.html#signum(double)" title="class or interface in java.lang"><CODE>Math.signum(double)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="signum(int)"><!-- --></A><H3>
signum</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.57"><B>signum</B></A>(int&nbsp;value)</PRE>
<DL>
<DD>Returns the signum of the int value, i.e. 1/-1/0 for a positive, 
 negative or zero value
<P>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Math.html#signum(double)" title="class or interface in java.lang"><CODE>Math.signum(double)</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="gcd(java.lang.Integer...)"><!-- --></A><H3>
gcd</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.72"><B>gcd</B></A>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Integer.html" title="class or interface in java.lang">Integer</A>...&nbsp;values)</PRE>
<DL>
<DD>Calculates the greatest common divisor of the specified integer numbers.
 This method might be useful to scale down a vector of integer numbers. 
 <p>
 If all numbers are negative, the resulting gcd is also negative. If all 
 numbers are zero, the result is zero. Otherwise, the result is positive.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>values</CODE> - values for which the gcd is to be computed
<DT><B>Returns:</B><DD>gcd of all values, negative if all values negative, zero
                                        if all values zero, positive otherwise</DL>
</DD>
</DL>
<HR>

<A NAME="gcd(int...)"><!-- --></A><H3>
gcd</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.94"><B>gcd</B></A>(int...&nbsp;values)</PRE>
<DL>
<DD>Calculates the greatest common divisor of the specified integer numbers.
 This method might be useful to scale down a vector of integer numbers. 
 <p>
 If all numbers are negative, the resulting gcd is also negative. If all 
 numbers are zero, the result is zero. Otherwise, the result is positive.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>values</CODE> - values for which the gcd is to be computed
<DT><B>Returns:</B><DD>gcd of all values, negative if all values negative, zero
                                        if all values zero, positive otherwise</DL>
</DD>
</DL>
<HR>

<A NAME="gcd(java.lang.Long...)"><!-- --></A><H3>
gcd</H3>
<PRE>
public static long <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.116"><B>gcd</B></A>(<A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/Long.html" title="class or interface in java.lang">Long</A>...&nbsp;values)</PRE>
<DL>
<DD>Calculates the greatest common divisor of the specified long numbers.
 This method might be useful to scale down a vector of long numbers. 
 <p>
 If all numbers are negative, the resulting gcd is also negative. If all 
 numbers are zero, the result is zero. Otherwise, the result is positive.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>values</CODE> - values for which the gcd is to be computed
<DT><B>Returns:</B><DD>gcd of all values, negative if all values negative, zero
                                        if all values zero, positive otherwise</DL>
</DD>
</DL>
<HR>

<A NAME="gcd(long...)"><!-- --></A><H3>
gcd</H3>
<PRE>
public static long <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.138"><B>gcd</B></A>(long...&nbsp;values)</PRE>
<DL>
<DD>Calculates the greatest common divisor of the specified long numbers.
 This method might be useful to scale down a vector of long numbers. 
 <p>
 If all numbers are negative, the resulting gcd is also negative. If all 
 numbers are zero, the result is zero. Otherwise, the result is positive.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>values</CODE> - values for which the gcd is to be computed
<DT><B>Returns:</B><DD>gcd of all values, negative if all values negative, zero
                                        if all values zero, positive otherwise</DL>
</DD>
</DL>
<HR>

<A NAME="gcd(int, int)"><!-- --></A><H3>
gcd</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.153"><B>gcd</B></A>(int&nbsp;iA,
                      int&nbsp;iB)</PRE>
<DL>
<DD>Returns the greatest common divisor of iA and iB using standard euclidian
 algorithm
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="extendedEuclidean(int, int)"><!-- --></A><H3>
extendedEuclidean</H3>
<PRE>
public static int[] <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.185"><B>extendedEuclidean</B></A>(int&nbsp;a,
                                      int&nbsp;b)</PRE>
<DL>
<DD>The extended euclidean algorithm solves the equation
 <tt>a*x + b*y = gcd(a,b)</tt>.
 <p>
 Returns an int array containing 3 elements {x, y, gcd(a, b)}.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="modularReciprocal(int, int)"><!-- --></A><H3>
modularReciprocal</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.219"><B>modularReciprocal</B></A>(int&nbsp;a,
                                    int&nbsp;mod)</PRE>
<DL>
<DD>Computes the reciprocal or multiplicative inverse of a (modulo mod). Note
 that a is only invertible if a and mod are coprime. If this is not the
 case, an <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang"><CODE>ArithmeticException</CODE></A> is thrown.
 <p>
 The returned value <tt>inv(a)</tt> meets the following equality:
 <tt>inv(a) * a = 1 (modulo mod)</tt>.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the multiplicative inverse of a (modulo mod), if it exists, and 
                        throws an exception otherwise.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - if a is not invertible (modulo mod)</DL>
</DD>
</DL>
<HR>

<A NAME="gcd(long, long)"><!-- --></A><H3>
gcd</H3>
<PRE>
public static long <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.253"><B>gcd</B></A>(long&nbsp;iA,
                       long&nbsp;iB)</PRE>
<DL>
<DD>Returns the greatest common divisor of iA and iB using standard euclidian
 algorithm
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="extendedEuclidean(long, long)"><!-- --></A><H3>
extendedEuclidean</H3>
<PRE>
public static long[] <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.285"><B>extendedEuclidean</B></A>(long&nbsp;a,
                                       long&nbsp;b)</PRE>
<DL>
<DD>The extended euclidean algorithm solves the equation
 <tt>a*x + b*y = gcd(a,b)</tt>.
 <p>
 Returns a long array containing 3 elements {x, y, gcd(a, b)}.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="modularReciprocal(long, long)"><!-- --></A><H3>
modularReciprocal</H3>
<PRE>
public static long <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.319"><B>modularReciprocal</B></A>(long&nbsp;a,
                                     long&nbsp;mod)</PRE>
<DL>
<DD>Computes the reciprocal or multiplicative inverse of a (modulo mod). Note
 that a is only invertible if a and mod are coprime. If this is not the
 case, an <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang"><CODE>ArithmeticException</CODE></A> is thrown.
 <p>
 The returned value <tt>inv(a)</tt> meets the following equality:
 <tt>inv(a) * a = 1 (modulo mod)</tt>.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the multiplicative inverse of a (modulo mod), if it exists, and 
                        throws an exception otherwise.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - if a is not invertible (modulo mod)</DL>
</DD>
</DL>
<HR>

<A NAME="modularReciprocal2pow32(int)"><!-- --></A><H3>
modularReciprocal2pow32</H3>
<PRE>
public static int <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.363"><B>modularReciprocal2pow32</B></A>(int&nbsp;a)</PRE>
<DL>
<DD>Computes the reciprocal or multiplicative inverse of a (modulo 2^32). 
 Note that a is only invertible if a and 2^32 are coprime, that is, if a
 is odd. If this is not the case, an <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang"><CODE>ArithmeticException</CODE></A> is 
 thrown.
 <p>
 The returned value <tt>inv(a)</tt> meets the following equality:
 <tt>inv(a) * a = 1 (modulo 2^32)</tt>.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the multiplicative inverse of a (modulo 2^32), if it exists (if 
                        a is odd), and throws an exception otherwise.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - if a is not invertible (modulo 2^32), that 
                                                                is, iv a is even</DL>
</DD>
</DL>
<HR>

<A NAME="modularReciprocal2pow64(long)"><!-- --></A><H3>
modularReciprocal2pow64</H3>
<PRE>
public static long <A HREF="../../../../src-html/ch/javasoft/util/numeric/IntegerUtil.html#line.394"><B>modularReciprocal2pow64</B></A>(long&nbsp;a)</PRE>
<DL>
<DD>Computes the reciprocal or multiplicative inverse of a (modulo 2^64). 
 Note that a is only invertible if a and 2^64 are coprime, that is, if a
 is odd. If this is not the case, an <A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang"><CODE>ArithmeticException</CODE></A> is 
 thrown.
 <p>
 The returned value <tt>inv(a)</tt> meets the following equality:
 <tt>inv(a) * a = 1 (modulo 2^64)</tt>.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>the multiplicative inverse of a (modulo 2^64), if it exists (if 
                        a is odd), and throws an exception otherwise.
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/j2se/1.5.0/docs/api/java/lang/ArithmeticException.html" title="class or interface in java.lang">ArithmeticException</A></CODE> - if a is not invertible (modulo 2^64), that 
                                                                is, iv a is even</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/IntegerUtil.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/util/numeric/DoubleUtil.html" title="class in ch.javasoft.util.numeric"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/util/numeric/Zero.html" title="class in ch.javasoft.util.numeric"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/util/numeric/IntegerUtil.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="IntegerUtil.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
